using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace Jenyay.Gui.Wizard
{
	public class WizardManager<ParamsT>: Form
		where ParamsT : new ()
	{
		/// <summary>
		///    ,   
		/// </summary>
		private ParamsT _params;

		public ParamsT Params
		{
			get { return _params; }
			set { _params = value; }
		}

		public WizardManager ()
		{
			InitializeComponent ();
			_params = new ParamsT ();
		}

		WizardPage<ParamsT> _currentPage = null;

		public void SetPage (WizardPage<ParamsT> page)
		{
			if (_currentPage != null)
			{
				_currentPage.Hide ();
				Controls.Remove (_currentPage);
			}

			page.Dock = DockStyle.Fill;
			page.Parent = this;
			Controls.Add (page);

			_currentPage = page;
			_currentPage.Visible = true;
			_currentPage.Init ();
		}

		public DialogResult Start (WizardPage<ParamsT> startPage)
		{
			this.SetPage (startPage);
			return this.ShowDialog ();
		}

		private void InitializeComponent ()
		{
			this.SuspendLayout ();
			// 
			// WizardManager
			// 
			this.ClientSize = new System.Drawing.Size (577, 467);
			this.Name = "WizardManager";
			this.ShowInTaskbar = false;
			this.ResumeLayout (false);

		}

	}
}
