using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace Jenyay.Gui.Wizard
{
	/// <summary>
	///   
	/// </summary>
	/// <typeparam name="WizardT">  typeparam>
	/// <typeparam name="ParamsT">   <typeparam>
	public partial class WizardPage<ParamsT> : UserControl
		where ParamsT : new ()
	{
		public WizardPage ()
		{
			InitializeComponent ();
		}


		//   
		private WizardManager<ParamsT> _wizard;

		public WizardManager<ParamsT> Wizard
		{
			get { return _wizard; }
		}


		public WizardPage (WizardManager<ParamsT> wizard, WizardPage<ParamsT> prevPage)
		{
			InitializeComponent ();

			_wizard = wizard;
			_prevPage = prevPage;
		}

		//      
		WizardPage<ParamsT> _prevPage = null;

		public WizardPage<ParamsT> PrevPage
		{
			get { return _prevPage; }
		}

		
		/// <summary>
		///      
		/// </summary>
		public virtual void Init ()
		{
		}

		//    
		protected virtual void Cancel ()
		{
			this.Wizard.DialogResult = DialogResult.Cancel;
			this.Wizard.Close ();
		}

		protected virtual void Back ()
		{
			this.Wizard.SetPage (_prevPage);
		}

		private void cancel_Click (object sender, EventArgs e)
		{
			Cancel ();
		}

		private void prev_Click (object sender, EventArgs e)
		{
			Back ();
		}
	}
}
